diff --git a/Tmain/disable-fixed-field.d/stderr-expected.txt b/Tmain/disable-fixed-field.d/stderr-expected.txt
index 062563190c..e7821ca2a4 100644
--- a/Tmain/disable-fixed-field.d/stderr-expected.txt
+++ b/Tmain/disable-fixed-field.d/stderr-expected.txt
@@ -1,6 +1,6 @@
-ctags: Warning: Cannot disable fixed field: 'N'{name}
-ctags: Warning: Cannot disable fixed field: 'F'{input}
-ctags: Warning: Cannot disable fixed field: 'P'{pattern}
-ctags: Warning: Cannot disable fixed field: 'N'{name}
-ctags: Warning: Cannot disable fixed field: 'F'{input}
-ctags: Warning: Cannot disable fixed field: 'P'{pattern}
+ctags: Warning: Cannot disable fixed field: 'N'{name} in ctags output mode
+ctags: Warning: Cannot disable fixed field: 'F'{input} in ctags output mode
+ctags: Warning: Cannot disable fixed field: 'P'{pattern} in ctags output mode
+ctags: Warning: Cannot disable fixed field: 'N'{name} in ctags output mode
+ctags: Warning: Cannot disable fixed field: 'F'{input} in ctags output mode
+ctags: Warning: Cannot disable fixed field: 'P'{pattern} in ctags output mode
diff --git a/Tmain/fixed-field-handling-in-json-format.d/input.c b/Tmain/fixed-field-handling-in-json-format.d/input.c
new file mode 100644
index 0000000000..4177b6f1d8
--- /dev/null
+++ b/Tmain/fixed-field-handling-in-json-format.d/input.c
@@ -0,0 +1 @@
+void main(void) {}
diff --git a/Tmain/fixed-field-handling-in-json-format.d/run.sh b/Tmain/fixed-field-handling-in-json-format.d/run.sh
new file mode 100644
index 0000000000..b57018d096
--- /dev/null
+++ b/Tmain/fixed-field-handling-in-json-format.d/run.sh
@@ -0,0 +1,16 @@
+# Copyright: 2021 Masatake YAMATO
+# License: GPL-2
+
+. ../utils.sh
+
+CTAGS="$1"
+
+is_feature_available "${CTAGS}" json
+
+CTAGS="${CTAGS} --quiet --options=NONE"
+
+echo '# --output-format=json --fields=+n-P'
+${CTAGS} --output-format=json --fields=+n-P -o - input.c
+
+echo '# --fields=+n-P --output-format=json'
+${CTAGS} --fields=+n-P --output-format=json -o - input.c
diff --git a/Tmain/fixed-field-handling-in-json-format.d/stderr-expected.txt b/Tmain/fixed-field-handling-in-json-format.d/stderr-expected.txt
new file mode 100644
index 0000000000..e69de29bb2
diff --git a/Tmain/fixed-field-handling-in-json-format.d/stdout-expected.txt b/Tmain/fixed-field-handling-in-json-format.d/stdout-expected.txt
new file mode 100644
index 0000000000..4c1439c3dc
--- /dev/null
+++ b/Tmain/fixed-field-handling-in-json-format.d/stdout-expected.txt
@@ -0,0 +1,4 @@
+# --output-format=json --fields=+n-P
+{"_type": "tag", "name": "main", "path": "input.c", "line": 1, "typeref": "typename:void", "kind": "function"}
+# --fields=+n-P --output-format=json
+{"_type": "tag", "name": "main", "path": "input.c", "line": 1, "typeref": "typename:void", "kind": "function"}
diff --git a/main/field.c b/main/field.c
index 546367adc3..711b384ef8 100644
--- a/main/field.c
+++ b/main/field.c
@@ -973,41 +973,21 @@ extern bool isFieldEnabled (fieldType type)
 	return getFieldObject(type)->def->enabled;
 }
 
-extern bool enableField (fieldType type, bool state, bool warnIfFixedField)
+extern bool enableField (fieldType type, bool state)
 {
 	fieldDefinition *def = getFieldObject(type)->def;
 	bool old = def->enabled;
-	if (writerDoesTreatFieldAsFixed (type))
-	{
-		if ((!state) && warnIfFixedField)
-		{
-			if (def->name && def->letter != NUL_FIELD_LETTER)
-				error(WARNING, "Cannot disable fixed field: '%c'{%s}",
-				      def->letter, def->name);
-			else if (def->name)
-				error(WARNING, "Cannot disable fixed field: {%s}",
-				      def->name);
-			else if (def->letter != NUL_FIELD_LETTER)
-				error(WARNING, "Cannot disable fixed field: '%c'",
-				      getFieldObject(type)->def->letter);
-			else
-				AssertNotReached();
-		}
-	}
-	else
-	{
-		getFieldObject(type)->def->enabled = state;
+	getFieldObject(type)->def->enabled = state;
 
-		if (isCommonField (type))
-			verbose ("enable field \"%s\": %s\n",
+	if (isCommonField (type))
+		verbose ("enable field \"%s\": %s\n",
 				 getFieldObject(type)->def->name,
 				 (state? "yes": "no"));
-		else
-			verbose ("enable field \"%s\"<%s>: %s\n",
+	else
+		verbose ("enable field \"%s\"<%s>: %s\n",
 				 getFieldObject(type)->def->name,
 				 getLanguageName (getFieldOwner(type)),
 				 (state? "yes": "no"));
-	}
 	return old;
 }
 
diff --git a/main/field_p.h b/main/field_p.h
index 204068370b..33d8ea5af4 100644
--- a/main/field_p.h
+++ b/main/field_p.h
@@ -43,7 +43,7 @@ extern fieldType getFieldTypeForOption (char letter);
    internally, each parser is not initialized. `LANG_IGNORE' is a bit faster. */
 extern fieldType getFieldTypeForName (const char *name);
 extern fieldType getFieldTypeForNameAndLanguage (const char *fieldName, langType language);
-extern bool enableField (fieldType type, bool state, bool warnIfFixedField);
+extern bool enableField (fieldType type, bool state);
 extern bool isCommonField (fieldType type);
 extern int     getFieldOwner (fieldType type);
 extern const char* getFieldDescription (fieldType type);
diff --git a/main/fmt.c b/main/fmt.c
index d7c99289dd..4569058af8 100644
--- a/main/fmt.c
+++ b/main/fmt.c
@@ -230,13 +230,13 @@ static fmtElement** queueTagField (fmtElement **last, long width, bool truncatio
 	else
 		cur->spec.field.raw_fmtstr = NULL;
 
-	enableField (ftype, true, false);
+	enableField (ftype, true);
 	if (language == LANG_AUTO)
 	{
 		fieldType ftype_next = ftype;
 
 		while ((ftype_next = nextSiblingField (ftype_next)) != FIELD_UNKNOWN)
-			enableField (ftype_next, true, false);
+			enableField (ftype_next, true);
 	}
 
 	cur->printer = printTagField;
diff --git a/main/options.c b/main/options.c
index 0e574978b8..563d1bf055 100644
--- a/main/options.c
+++ b/main/options.c
@@ -173,6 +173,7 @@ optionValues Option = {
 	.putFieldPrefix = false,
 	.maxRecursionDepth = 0xffffffff,
 	.interactive = false,
+	.fieldsReset = false,
 #ifdef WIN32
 	.useSlashAsFilenameSeparator = FILENAME_SEP_UNSET,
 #endif
@@ -1311,7 +1312,10 @@ static void resetFieldsOption (langType lang, bool mode)
 
 	for (i = 0; i < countFields (); ++i)
 		if ((lang == LANG_AUTO) || (lang == getFieldOwner (i)))
-			enableField (i, mode, false);
+			enableField (i, mode);
+
+	if ((lang == LANG_AUTO || lang == LANG_IGNORE)&& !mode)
+		Option.fieldsReset = true;
 }
 
 static void processFieldsOption (
@@ -1327,6 +1331,8 @@ static void processFieldsOption (
 
 	longName = vStringNewOrClearWithAutoRelease (longName);
 
+	Option.fieldsReset = false;
+
 	if (*p == '*')
 	{
 		resetFieldsOption (LANG_IGNORE, true);
@@ -1370,7 +1376,7 @@ static void processFieldsOption (
 			if (t == FIELD_UNKNOWN)
 				error(FATAL, "no such field: \'%s\'", vStringValue (longName));
 
-			enableField (t, mode, true);
+			enableField (t, mode);
 
 			inLongName = false;
 			vStringClear (longName);
@@ -1385,7 +1391,7 @@ static void processFieldsOption (
 					error(WARNING, "Unsupported parameter '%c' for \"%s\" option",
 					      c, option);
 				else
-					enableField (t, mode, true);
+					enableField (t, mode);
 			}
 			break;
 	}
@@ -2962,13 +2968,13 @@ static void enableLanguageField (langType language, const char *field, bool mode
 	t = getFieldTypeForNameAndLanguage (field, language);
 	if (t == FIELD_UNKNOWN)
 		error(FATAL, "no such field: \'%s\'", field);
-	enableField (t, mode, (language != LANG_AUTO));
+	enableField (t, mode);
 	if (language == LANG_AUTO)
 	{
 		fieldType ftype_next = t;
 
 		while ((ftype_next = nextSiblingField (ftype_next)) != FIELD_UNKNOWN)
-			enableField (ftype_next, mode, (language != LANG_AUTO));
+			enableField (ftype_next, mode);
 	}
 }
 
diff --git a/main/options_p.h b/main/options_p.h
index bbb5b8def7..935ef92f53 100644
--- a/main/options_p.h
+++ b/main/options_p.h
@@ -118,6 +118,7 @@ typedef struct sOptionValues {
 	unsigned int patternLengthLimit; /* --pattern-length-limit=N */
 	bool putFieldPrefix;		 /* --put-field-prefix */
 	unsigned int maxRecursionDepth; /* --maxdepth=<max-recursion-depth> */
+	bool fieldsReset;				/* --fields=[^+-] */
 	enum interactiveMode { INTERACTIVE_NONE = 0,
 						   INTERACTIVE_DEFAULT,
 						   INTERACTIVE_SANDBOX, } interactive; /* --interactive */
diff --git a/main/writer-ctags.c b/main/writer-ctags.c
index 3a3ce22dd1..741dc30d3d 100644
--- a/main/writer-ctags.c
+++ b/main/writer-ctags.c
@@ -389,17 +389,18 @@ static int writeCtagsPtagEntry (tagWriter *writer CTAGS_ATTR_UNUSED,
 #undef OPT
 }
 
+static fieldType fixedFields [] = {
+	FIELD_NAME,
+	FIELD_INPUT_FILE,
+	FIELD_PATTERN,
+};
+
 static bool treatFieldAsFixed (int fieldType)
 {
-	switch (fieldType)
-	{
-	case FIELD_NAME:
-	case FIELD_INPUT_FILE:
-	case FIELD_PATTERN:
-		return true;
-	default:
-		return false;
-	}
+	for (int i = 0; i < ARRAY_SIZE(fixedFields); i++)
+		if (fixedFields [i] == fieldType)
+			return true;
+	return false;
 }
 
 static void checkCtagsOptions (tagWriter *writer CTAGS_ATTR_UNUSED)
@@ -417,7 +418,7 @@ static void checkCtagsOptions (tagWriter *writer CTAGS_ATTR_UNUSED)
 			   getFieldLetter (FIELD_KIND_LONG),
 			   getFieldLetter (FIELD_KIND_KEY),
 			   getFieldName (FIELD_KIND_KEY));
-		enableField (FIELD_KIND_LONG, true, true);
+		enableField (FIELD_KIND_LONG, true);
 	}
 	if (isFieldEnabled (FIELD_SCOPE_KEY)
 		&& !isFieldEnabled (FIELD_SCOPE))
@@ -430,6 +431,30 @@ static void checkCtagsOptions (tagWriter *writer CTAGS_ATTR_UNUSED)
 			   getFieldLetter (FIELD_SCOPE),
 			   getFieldLetter (FIELD_SCOPE_KEY),
 			   getFieldName (FIELD_SCOPE_KEY));
-		enableField (FIELD_SCOPE, true, true);
+		enableField (FIELD_SCOPE, true);
+	}
+
+	for (int i = 0; i < ARRAY_SIZE (fixedFields); i++)
+	{
+		if (!isFieldEnabled (fixedFields [i]))
+		{
+			enableField (fixedFields [i], true);
+
+			if (Option.fieldsReset)
+				continue;
+
+			const char *name = getFieldName (fixedFields [i]);
+			unsigned char letter = getFieldLetter (fixedFields [i]);
+
+			if (name && letter != NUL_FIELD_LETTER)
+				error(WARNING, "Cannot disable fixed field: '%c'{%s} in ctags output mode",
+				      letter, name);
+			else if (name)
+				error(WARNING, "Cannot disable fixed field: {%s} in ctags output mode",
+				      name);
+			else if (letter != NUL_FIELD_LETTER)
+				error(WARNING, "Cannot disable fixed field: '%c' in ctags output mode",
+				      letter);
+		}
 	}
 }
diff --git a/main/writer-json.c b/main/writer-json.c
index 4cb4194d0f..6442cc6f37 100644
--- a/main/writer-json.c
+++ b/main/writer-json.c
@@ -172,15 +172,15 @@ static void addExtensionFields (json_t *response, const tagEntryInfo *const tag)
 	   That cannot be changed to keep the compatibility of tags file format.
 	   Use FIELD_KIND_KEY instead */
 	if (isFieldEnabled (FIELD_KIND) || isFieldEnabled (FIELD_KIND_LONG))
-		enableField (FIELD_KIND_KEY, true, false);
+		enableField (FIELD_KIND_KEY, true);
 
 	/* FIELD_SCOPE has no name; getFieldName (FIELD_KIND_KEY) returns NULL.
 	   That cannot be changed to keep the compatibility of tags file format.
 	   Use FIELD_SCOPE_KEY and FIELD_SCOPE_KIND_LONG instead. */
 	if (isFieldEnabled (FIELD_SCOPE))
 	{
-		enableField (FIELD_SCOPE_KEY, true, false);
-		enableField (FIELD_SCOPE_KIND_LONG, true, false);
+		enableField (FIELD_SCOPE_KEY, true);
+		enableField (FIELD_SCOPE_KIND_LONG, true);
 	}
 
 	for (k = FIELD_EXTENSION_START; k <= FIELD_BUILTIN_LAST; k++)
